<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
class LightboxService
    {
    // database object
    var $_db   = null;
    var $error = null;
    var $table_prefix=null;
    function __construct($db,$table_prefix) {$this->_db=$db;$this->table_prefix=$table_prefix; }

    public function getNum()
    {
        $sql   ="select count(*) as num from ".$this->table_prefix."lightboxes";
        $result=$this->_db->query($sql);
        $num    =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $num['num'];  
    }    
    public function del($ids)
        {
        foreach ($ids as $id)
            {
            $sql   = "delete from ".$this->table_prefix."lightboxes where lightbox_id = '$id'";
            $result=$this->_db->query($sql);
            $sql   = "delete from ".$this->table_prefix."lightboxmatch where lightbox_id = '$id'";
            $result=$this->_db->query($sql);
            }
        }
    public function delUsers($userId)
    {
            $sql   = "delete from ".$this->table_prefix."lightboxes where user_id = '$userId'";
            $result=$this->_db->query($sql);
    }
    public function delImages($imageId)
    {
            $sql   = "delete from ".$this->table_prefix."lightboxmatch where image_id = '$imageId'";
            $result=$this->_db->query($sql);
    }   
    public function search($lightboxId)
    {
       if($lightboxId!= '')
       {
           $sql="update ".$this->table_prefix."lightboxes set lightbox_lastvisit=".time()." where lightbox_id=".$lightboxId;
           $result            =$this->_db->query($sql); 
       }     
       $sql="select *,(select count(*) from ".$this->table_prefix."lightboxmatch where lightbox_id=lb.lightbox_id) as num from ".$this->table_prefix."lightboxes lb where user_id=".$_SESSION['userId']." order by lightbox_lastvisit desc";
       $result    =$this->_db->query($sql);
       $lightboxes      =$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);    
       $last_modified=(empty($lightboxes)) ? array("lightbox_id"=>-1,"num"=>0,"lightbox_name"=>"no lightbox") : $lightboxes[0];
       $sql="select * from ".$this->table_prefix."images where image_id in (select image_id from ".$this->table_prefix."lightboxmatch where lightbox_id=".$last_modified['lightbox_id'].")"; 
       $result    =$this->_db->query($sql);
       $images      =$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
       $this->_db->free_result($result);
       $hashlist=$this->create_lightboxhashlist($lightboxes);
               return array
            (
            "hashlist"    => $hashlist,
            "active"=>$last_modified,
            "images" => $images
            );  
    }  
    public function searchNames()
    {  
       $sql="select * from ".$this->table_prefix."lightboxes where user_id=".$_SESSION['userId']." order by lightbox_lastvisit desc";
       $result    =$this->_db->query($sql);
       $lightboxes      =$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
       $this->_db->free_result($result);
       $hashlist=$this->create_lightboxhashlist($lightboxes);
       return $hashlist;
    }   
    public function searchByAdmin($data)
    {
        $sql='';
        $sql.="select * from ".$this->table_prefix."lightboxes, ".$this->table_prefix."users ";
        $condition='';       
        $id_condition='';
        if (trim($data['id']) != '')
            {
            $id_condition.=" lightbox_id =" . trim($data['id']);
            }
        if ($id_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$id_condition;
                }
            else
                {
                $condition.=" and " . $id_condition;
                }
            }           
        $user_id_condition='';
        if (trim($data['user_id']) != '')
            {
            $user_id_condition.=" ".$this->table_prefix."users.user_id =" . trim($data['user_id']);
            }
        if ($user_id_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$user_id_condition;
                }
            else
                {
                $condition.=" and " . $user_id_condition;
                }
            }           
        $user_name_condition='';
        $terms=preg_split("/[\s]+/", $data['user_name'], -1, PREG_SPLIT_NO_EMPTY);
        $flag=true;
        foreach ($terms as $term)
            {
            if ($flag)
                {
                $user_name_condition.=" user_name like '%" . $term . "%'";
                $flag=false;
                }
            else
                {
                $user_name_condition.=" and user_name like '%" . $term . "%'";
                }
            }
        if ($user_name_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$user_name_condition;
                }
            else
                {
                $condition.=" and " . $user_name_condition;
                }
            }            
                $name_condition='';
        $terms=preg_split("/[\s]+/", $data['name'], -1, PREG_SPLIT_NO_EMPTY);
        $flag=true;
        foreach ($terms as $term)
            {
            if ($flag)
                {
                $name_condition.=" lightbox_name like '%" . $term . "%'";
                $flag=false;
                }
            else
                {
                $name_condition.=" and lightbox_name like '%" . $term . "%'";
                }
            }
        if ($name_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$name_condition;
                }
            else
                {
                $condition.=" and " . $name_condition;
                }
            }           
                $description_condition='';
        $terms=preg_split("/[\s]+/", $data['description'], -1, PREG_SPLIT_NO_EMPTY);
        $flag=true;
        foreach ($terms as $term)
            {
            if ($flag)
                {
                $description_condition.=" lightbox_description like '%" . $term . "%'";
                $flag=false;
                }
            else
                {
                $description_condition.=" and lightbox_description like '%" . $term . "%'";
                }
            }
        if ($description_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$description_condition;
                }
            else
                {
                $condition.=" and " . $description_condition;
                }
            }            
                $public_condition='';
        if (trim($data['public']) == '1')
            {
            $public_condition.=" lightbox_public='1' ";
            }
        else if (trim($data['public']) == '0')
            {
            $public_condition.=" lightbox_public='0' ";
            }
        if ($public_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$public_condition;
                }
            else
                {
                $condition.=" and " . $public_condition;
                }
            }
        $lastvisitafter_condition='';
        $data['lastvisitafter']=timeTrans($data['lastvisitafter']);
        if (trim($data['lastvisitafter']) != '')
            {
            $lastvisitafter_condition.=" lightbox_lastvisit >= " . trim($data['lastvisitafter']);
            }
        if ($lastvisitafter_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$lastvisitafter_condition;
                }
            else
                {
                $condition.=" and " . $lastvisitafter_condition;
                }
            }
        $lastvisitbefore_condition='';
        $data['lastvisitbefore']=timeTrans($data['lastvisitbefore']);
        if (trim($data['lastvisitbefore']) != '')
            {
            $lastvisitbefore_condition.=" lightbox_lastvisit <= " . trim($data['lastvisitbefore']);
            }
        if ($lastvisitbefore_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$lastvisitbefore_condition;
                }
            else
                {
                $condition.=" and " . $lastvisitbefore_condition;
                }
            }            
        $sql.=" where ".$this->table_prefix."lightboxes.user_id = ".$this->table_prefix."users.user_id ";
        if ($condition != '')
            {
            $sql.=" and " . $condition;
            }
        switch ($data['sortby'])
            {
            case "user_name":
                $sql.=" order by user_name " . $data['direction'];
                break;
            case "name":
                $sql.=" order by lightbox_name " . $data['direction'];
                break;
            case "lastvisit":
                $sql.=" order by lightbox_lastvisit " . $data['direction'];
                break;
            }        
                $result=$this->_db->query($sql);
        $num=$this->_db->get_numrows($result);
        $sql.=" limit " . ($data['requestpage'] - 1) * $data['rows_per_page'] . " , " . ($data['rows_per_page']);
        $result=$this->_db->query($sql);
        $lightboxes=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        $pagecount =ceil($num / ($data['rows_per_page']));
        $navigation=create_navigation($pagecount, $data['requestpage']);
        return array
            (
            "nav"    => $navigation,
            "lightboxes" => $lightboxes
            );
    } 
    private function create_lightboxhashlist($lightboxes)
    {
        $hashlist='';
        $flag =true;
        $hashlist.="{";
        foreach($lightboxes as $lightbox)
        {
             if ($flag)
                    {
                    $hashlist.='"'.$lightbox['lightbox_id'].'":{"last_modified":'.$lightbox['lightbox_lastvisit'].',"id":'.$lightbox['lightbox_id'].',"title":"'.$lightbox['lightbox_name'].'"}';
                    $flag=false;
                    }
                else
                    {
                    $hashlist.=',"'.$lightbox['lightbox_id'].'":{"last_modified":'.$lightbox['lightbox_lastvisit'].',"id":'.$lightbox['lightbox_id'].',"title":"'.$lightbox['lightbox_name'].'"}';
                    }
        }
        $hashlist.="}";
        return $hashlist;
    } 
    public function getInfo()
    {
        global $lang;
        $hashlist='';
        $flag =true;
        $hashlist.="{";
        foreach($lang as $index=>$value)
        {
             if(preg_match('/^lightbox_info_/',$index))
             {
             $index= substr($index,14);
             if ($flag)
                    {
                    $hashlist.='"'.$index.'":"'.$value.'"';
                    $flag=false;
                    }
                else
                    {
                    $hashlist.=',"'.$index.'":"'.$value.'"';
                    }
             }
        }
        $hashlist.="}";
        return $hashlist; 
    }
    public function copy_to_lightbox($lightboxId,$imageIds)
    {
        $ids=explode(",",$imageIds);
        foreach($ids as $id)
        {
            if(!$this->existMatch($lightboxId,$id))
            {
                $sql="insert into ".$this->table_prefix."lightboxmatch(lightbox_id,image_id) values($lightboxId,$id)";
                $result=$this->_db->query($sql);
            }
        }
    } 
    public function remove_from_lightbox($lightboxId,$imageIds)
    {
        $ids=explode(",",$imageIds);
        foreach($ids as $id)
        {
                $sql="delete from ".$this->table_prefix."lightboxmatch where lightbox_id=$lightboxId and image_id=$id";
                $result=$this->_db->query($sql);
        }
    }   
    public function create_lightbox($lightboxName)
    {
            if(!$this->exist($lightboxName))
            {
                $user_id= $_SESSION['userId'];
                $lightbox_name=$lightboxName;
                $lightbox_public=1;
                $lightbox_lastvisit=time();
                $sql="insert into ".$this->table_prefix."lightboxes(user_id,lightbox_name,lightbox_public,lightbox_lastvisit) values('". $user_id . "','" . $lightbox_name . "','". $lightbox_public . "','". $lightbox_lastvisit . "')";
                $result=$this->_db->query($sql);
            }
    }   
    public function rename_lightbox($lightboxId,$lightboxName)
    {
                   $sql="update ".$this->table_prefix."lightboxes set lightbox_name='$lightboxName' where lightbox_id=$lightboxId";
                $result=$this->_db->query($sql);
    }   
    public function delete_lightbox($lightboxId)
    {
        $sql="delete from ".$this->table_prefix."lightboxmatch where lightbox_id=$lightboxId";
                $result=$this->_db->query($sql);
                $sql="delete from ".$this->table_prefix."lightboxes where lightbox_id=$lightboxId";
                $result=$this->_db->query($sql);
    } 
    private function exist($lightboxName)
      {
         $sql   ="select * from ".$this->table_prefix."lightboxes where user_id=".$_SESSION['userId']." and lightbox_name='$lightboxName'"; 
         return $this->_db->not_empty($sql);
      }    
    private function existMatch($lightboxId,$imageId)
      {
         $sql   ="select * from ".$this->table_prefix."lightboxmatch where lightbox_id=$lightboxId and image_id=$imageId"; 
         return $this->_db->not_empty($sql);
      }
       
    }